Bug 445674 - Direct I/O cache invalidation after sync writes
Summary: Direct I/O cache invalidation after sync writes
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel
Version: 5.1
Hardware: All
OS: Linux
high
high
Target Milestone: rc
: ---
Assignee: Jeff Moyer
QA Contact: Martin Jenner
URL:
Whiteboard:
Keywords: Regression
Depends On:
Blocks: KernelPrio5.3
TreeView+ depends on / blocked
 
Reported: 2008-05-08 13:52 UTC by David Mair
Modified: 2009-01-20 19:57 UTC (History)
6 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2009-01-20 19:57:24 UTC


Attachments (Terms of Use)
dio: fix cache invalidation after sync writes (1.20 KB, patch)
2008-07-03 15:49 UTC, Jeff Moyer
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2009:0225 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 5.3 kernel security and bug fix update 2009-01-20 16:06:24 UTC

Description David Mair 2008-05-08 13:52:47 UTC
Description of problem:
In BZ232715 a patch from upstream was committed to resolve double AIO completion
due to invalidate_inode_pages2 failure.  Unfortunately that patch introduced a
regression in the kernel that can cause a transient journal file corruption.  A
Red Hat ISV partner reported this problem to Red Hat very recently.

Version-Release number of selected component (if applicable):
RHEL5.1 (kernel-2.6.18-53)

How reproducible:
Can be reproduced

Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
This problem was resolved in the upstream kernel with commit
bdb76ef5a4bc8676a81034a443f1eda450b4babb ("dio: fix cache invalidation after
sync writes")

A thread on lkml (including patch) can be found at the link below.

http://kerneltrap.org/mailarchive/linux-kernel/2007/10/26/360497

Comment 1 RHEL Product and Program Management 2008-05-08 14:05:18 UTC
This bugzilla has Keywords: Regression.  

Since no regressions are allowed between releases, 
it is also being proposed as a blocker for this release.  

Please resolve ASAP.

Comment 2 Jeff Moyer 2008-05-28 18:49:28 UTC
We have a regression test for this (aio-dio-regress) which gets run through
RHTS.  I also modified the test to check the async DIO case, and there is an
additional failure there.  I have a patch that I'm running by our performance
team for that.  Once I have sign-off from them, I'll post the two patches here.

Again, test for this is covered by the aio-dio-regress regression tests that we
run via RHTS.

Comment 3 RHEL Product and Program Management 2008-05-28 18:59:01 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 5 Jeff Moyer 2008-07-03 15:49:38 UTC
Created attachment 310935 [details]
dio: fix cache invalidation after sync writes

This patch fixes the aio-dio-regress test case.

Comment 6 Don Zickus 2008-07-23 18:55:40 UTC
in kernel-2.6.18-99.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Comment 11 errata-xmlrpc 2009-01-20 19:57:24 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html


Note You need to log in before you can comment on or make changes to this bug.